#ifndef MLSmain_H__
#define MLSmain_H__

#include <list>
#include <vector>
#include <string>
	
#include "MLSmcd.h"
#include "drawutil.h"
#include "strutil.h"

typedef unsigned int uint;


class MLSmain
{
protected:

	struct file
	{	
		std::string name;
		
		char date[9];
		char time[6];
		char attr[11]; // drwxrwxrwx
		uint size;
		bool selected;
		
		time_t mtime;
		mode_t mode;
		
		color_entry *color;		
		bool bDir() {return attr[0]=='d';}
		std::string ext()
		{
			std::string::size_type p= name.rfind(".");
			if (p == std::string::npos) 
				return "";
			return name.substr(p+1);		
		}
	};		
	typedef std::vector<file *>::iterator pFileIterator;
	
	std::vector<file *> memory_pool; // 메모리 풀..	 얼마나 빨라질지는..
	std::vector<file *> file_list;   // 지금 리스트에 나타낼 파일들.,
		
	std::string path;  // path
	
	uint sel_size; // 선택한 것들 크기
	uint sel_num;  // 선택한 것들의 개수
			
	uint cur, page; // 커서
	int ncol, nrow, npage;
	uint ndir, nfile, dir_size;
	
	std::string strSearch;
	
	bool bExit;
	
	
public:
	MLSmain();
	~MLSmain();	
	void proc();
	
	// commands
	int command(std::string);
	
	int cmd_help();
	int cmd_rename();
	int cmd_view();
	int cmd_edit();	
	int cmd_copy();
	int cmd_move();
	int cmd_remove();
	int cmd_menu();
	int cmd_attr();
	int cmd_mcd();

	// read	
	int read(std::string, bool preserve = false);
	
	// draw	
	void draw();
	void drawfile1();
	void drawfile2();
	void drawfile3();
	void drawfile4();
	void drawfile5();
	void drawfile6();
	
	
	// select
	void select(file &);
	void deselect(file &);	
	
	std::vector<std::string> &GetSelection(int &size, bool bDirExpansion = false);
	
	// search
	
	int  search(std::string &);
	
	
	
protected:

class is_dir
{
public:
	bool operator()(file *a)
	{
		return a->bDir();
	}
};

class sort_color
{
public:
	bool operator()(file *a, file *b)
	{
		if (a->color==b->color)	return a->name < b->name;
		return a->color < b->color;
	}

};

class sort_name
{
public:
	bool operator()(file *a, file *b)
	{
		return a->name < b->name;		
	}
};

class sort_ext
{
public:
	bool operator()(file *a, file *b)
	{
		if (a->ext()==b->ext())	return a->name < b->name;
		return a->ext() < b->ext();
	}
};

class sort_size
{
public:
	bool operator()(file *a, file *b)
	{
		if (a->size==b->size)	return a->name < b->name;
		return a->size < b->size;	
	}
};

class sort_time
{
public:
	bool operator()(file *a, file *b)
	{
		if (a->mtime==b->mtime)	return a->name < b->name;
		return a->mtime < b->mtime;
	}
};

};

#endif 

