#include <string>
#include <ncurses.h>
#include "mls.h"
#include "MLSmain.h"
#include "strutil.h"
#include "dialog.h"
#include "config.h"
#include <sys/stat.h>

using namespace std;
using namespace strutil;

int MLSmain::command(string p)
{	
	string arg;
	bool   bFlag=false, bPause=false, bParam=false;
	
	file &rf=*file_list[cur];
	
	if (!sel_num && p.find("%S")!=string::npos) return 0;
	if (p.find("%E")!=string::npos && rf.ext() == "") return 0;
	if (p.find("%N")!=string::npos && rf.name.rfind('.') == 0) return 0;
	if (p.find("%s")!=string::npos && rf.name == "..") return 0;
	if (p.find("%Q")!=string::npos)
	{
		int p=YNBox("Do you want to run this operation?", YN_N);
		
		if (p!=YN_Y) return 0;		
	}
	
	if (p=="") return 0;	

	
	// 커맨드
	if (p[0]=='<')
	{// 커맨드 이후 부분은 무시.
		string c=tolower(getbetween(p, '<' ,'>'));
		
		if (c == "exit")
		{
			bExit=true;
			return 0;
		}
		if (c == "refresh")
		{
			read(".", true);
			return 0;
		}
		
		if (c == "mcd")
		{
			MLSmcd mcd;
			mcd.setCur(path);
			if (!mcd.proc()) return 1;
			
			read(mcd.getCur());
			return 0;
		}
		if (c == "copy") return cmd_copy();
		
		if (c == "edit")
		{
			return command(conf.extern_editor + " %F"); // 재귀방지 처리가 필요
		}
		if (c == "view")
		{
			return command(conf.extern_viewer + " %F"); // 재귀방지 처리가 필요			
		}
		
		if (c == "mkdir")
		{
			string p;
			if (InputBox("Make Directory", p)<0) return 1;
			
			struct stat statbuf;
			
			if (stat(p.c_str(), &statbuf)!=-1)
			{
				MsgBox("Error","Directory exists");
				return 1;				
			}
			
			if (mkdir(p.c_str(), 0755)==-1)
			{
				MsgBox("Error","Fail to make a directory");
				return -1;
			}
			read(".", true);
			return 0;	
			
		}
		if (c == "rename")
		{		
			struct stat statbuf;
			string ren = file_list[cur]->name;
			
			if (ren == "..") return 0;
			
			if (InputBox("rename", ren)<0) return 1;
			
			if (lstat(ren.c_str(), &statbuf) != -1)			
			{
				MsgBox("Error", "fail : name exists");
				return 0;
			}
			
			if (rename(file_list[cur]->name.c_str(), ren.c_str()) == -1)
			{
				MsgBox("Error", "fail to rename");
				return 0;
			}
				
			file_list[cur]->name=ren;
				
			read(".", true);
			return 0;
		}		
		
		return 0;						
	}
	
	// 파싱
	for (string::iterator i = p.begin(); i!= p.end(); i++)
	{
		if (*i == '%')
		{
			bFlag = true;
			continue;
		}
		if (bFlag)
		{
			switch(*i)
			{
			case '1':			
			case 'F':
				arg += addslashes(rf.name);
				break;
			case 'N':
			{
				string::size_type p = rf.name.rfind('.');
				
				if (p!=string::npos)
					arg += addslashes(rf.name.substr(0, p-1));
				else
					arg+= addslashes (rf.name);
				break;
			}			
			
			case 'E':
				arg += addslashes(rf.ext());
				break;
			case 'W':
				bPause = true;
				break;
			case '%':
				arg += '%';			
				break;
			case 'S':
			{
				bool first = true;
				for (pFileIterator i = file_list.begin(); i!=file_list.end(); i++)
					if ((*i)->selected)
					{
						if (first) first=false;
						else arg+=' ';
						arg += addslashes((*i)->name);
					}
				break;
			}
			
			case 's':
			{
				if (sel_num)
				{
					bool first = true;
					for (pFileIterator i = file_list.begin(); i!=file_list.end(); i++)
						if ((*i)->selected)
						{
							if (first) first=false;
							else arg+=' ';
							arg += addslashes((*i)->name);
						}
				}
				else 
					arg += addslashes(rf.name);
				
				break;
			}		
			
			case 'D':
			{
				MLSmcd mcd;
				mcd.setCur(path);
				if (!mcd.proc()) return 0;
				arg += mcd.getCur();
				break;		
			}
			case 'P':
				bParam= true;
			
				break;
			}
			
			bFlag = false;			
			continue;			
		}		
		arg += *i;
	}	
	
	if (bParam)
		if (InputBox("Edit Parameter", arg)<0) return 0;
		
	// 실행
	destroy();
	int r=system(arg.c_str());
	init();
	
	if (bPause) getch();
	
	read(".", true);	
	
	return r;
	
}
