#include <string>
#include <sys/stat.h>
#include <errno.h>

#include "MLSmain.h"
#include "MLSmcd.h"
#include "dialog.h"
#include "strutil.h"

using namespace std;
using namespace strutil;

int MLSmain::cmd_copy()
{
	MLSmcd mcd("Select the directory where you want copy these files");
	mcd.setCur(path);
	if (!mcd.proc()) return -1;
	
	string msg = "To " + mcd.getCur();
	
	StatBox s("Copy", msg.c_str());	
	s.setUL("Calculating file sizes...");
	s.show();	
	// 1. 선택한 것을 하는 것인가..
	// 2. 그냥 한 파일만 복사하는 것인가
	
	int size;	
	vector<string> &files=GetSelection(size, true);
	
	struct stat stat_bufs;	
	FILE *fp, *out;	
	char count[25];
	char *buf = new char[65536]; 
	uint last_size, p=1, p_size=0, c_size;
	string sizes = toregular(size);	
	int key;
		
	bool bExit=false;
	bool bsDir=true;
	
	// /home/ioklo/ 에서 복사 시작  /p/로..
	// /home/ioklo/mls/p.dir   ==> /p/mls/p.dir
	
	// /home/ioklo/ 현재 디렉토리 source_path
	// /p/          타겟 디렉토리 target_path
	// mls/         복사시점 디렉토리 cur_path
	// p.dir        파일 이름  cur_name
	// /p/mls/      복사점..  tcur_path = target_path + cur_path
	
	// mls/p.dir    = cur_path + cur_name
	// /p/mls/p.dir =  tcur_path + cur_name
	
	string target_path = mcd.getCur();
	
	string source_name;
	string target_name;
	
	string cur_path;
	string tcur_path = target_path;
	
	// 파일 복사
	for (vector<string>::iterator i=files.begin(); i!=files.end(); ++i)
	{
		string &cur_name = *i;		
		
		if (cur_name.empty()) continue;
		if (cur_name[cur_name.size()-1]=='/') //  디렉토리 이면..
		{
			bsDir = true;			
			// /p/mls/
			cur_path = cur_name;
			tcur_path = target_path + cur_name;
						
			// 디렉토리를 만든다.
			if (mkdir(tcur_path.c_str(), 0755)==-1)
			{// 실패하면..				
				bsDir = false;
				/*
				if (errno == EEXIST)
				{
					lstat(tcur_path.c_str(), &stat_bufs);
					if (S_ISDIR(stat_bufs.st_mode)) bsDir = true; // 디렉토리라면 계속 복사한다
				}
				else*/ MsgBox("Error", "Directory Making error");
				break;
			}
			continue;
		}
		
		// 이번 디렉토리가 실패이면.. 다음 디렉토리때까지  복사하지 않는다.
		if (!bsDir) continue;	
		
		source_name = cur_path + cur_name;
		target_name = tcur_path + cur_name;
			
		if (lstat(source_name.c_str(), &stat_bufs)==-1) continue; // 사실 에러메세지 내야 할 부분
					
		s.setUL((*i).c_str());
		sprintf(count, "<%d/%d>", p, files.size());
		s.setBL(count);
		s.setBR(sizes.c_str());
		
		
		fp=fopen(source_name.c_str(), "rb");
		
		
		c_size=0;
		s.show();
		
		if (lstat(target_name.c_str(), &stat_bufs)!=-1)
		{
			string t = "Overwrite " + (*i);
			int yn=YNBox(t.c_str(), YN_N);
			s.redraw();
			if (yn==-1) break;
			if (yn==YN_N) 
			{
				c_size += stat_bufs.st_size;
				p++;
				continue;
			}
		}		
		nodelay(stdscr, TRUE);
		if (fp)		
		{		
		out=fopen(target_name.c_str(), "wb");				
			while(!feof(fp))
			{
				key=getch();
							
				if (key!=-1)
				{
					int yn=YNBox("Do you want to stop copy operation?", YN_N);
					s.redraw();
					if (yn==YN_Y)
					{
						bExit=true;
						break;
					}
				}				
				
				last_size = fread(buf, 1, 65536, fp);			
				fwrite(buf, 1, last_size, out);
				
				c_size +=last_size;
				p_size +=last_size;
				
				s.setUR(toregular(p_size).c_str());
				
				if (stat_bufs.st_size) s.setU((int)((float)c_size/(float)stat_bufs.st_size* 60));
				if (size) 
				{
					s.setB((int)((float)p_size/(float)size* 60));
				}
				s.show();
			}
		fclose(out);
		}
		fclose(fp);
		nodelay(stdscr, FALSE);
		if (bExit) break;
		
		p++;								
	}
	delete []buf;
	return 1;
}

