#include <dirent.h>
#include <sys/stat.h>
#include <unistd.h>
#include <queue>
#include <deque>

#include "MLSmain.h"

using namespace std;

vector<string> &MLSmain::GetSelection(int &size, bool bDirExpansion)
{
	static vector<string> sel;
	queue<string, deque<string> > dirs;	
	sel.clear();
	size=0;
	
	
	if (sel_num == 0)
	{
		if (file_list[cur]->name != "..")
		{
			if (bDirExpansion && file_list[cur]->bDir())
				dirs.push(file_list[cur]->name + '/');
			else
			{
				sel.push_back(file_list[cur]->name);
				size += file_list[cur]->size;
			}
		}
	}
	
	else 	
	for (pFileIterator i= file_list.begin(); i!=file_list.end(); ++i)
	{
		if ((*i)->selected)
		{
			if (bDirExpansion && (*i)->bDir())
				dirs.push((*i)->name + '/');
			else 
			{
				sel.push_back((*i)->name);
				size += (*i)->size;
			}
		}
	}
	
	if (bDirExpansion) // Dir 밑으로 확장시킨다
	{
		DIR        *handle;
		dirent     *pFile;
		struct stat stat_bufs;		
		
		while(!dirs.empty())
		{
			string p = dirs.front();
			dirs.pop();
			
			chdir (path.c_str());		
			if (chdir (p.c_str())==-1) continue;
			if ((handle = opendir("."))==NULL) continue;
			
			sel.push_back(p);
			
			while((pFile = readdir(handle)))
			{		
				if (!strcmp(pFile->d_name, ".")) continue;		
				if (!strcmp(pFile->d_name, "..")) continue;
				
				if (lstat(pFile->d_name, &stat_bufs)==-1) continue;				
				if (S_ISDIR (stat_bufs.st_mode)) dirs.push(p + pFile->d_name + '/');
				else 
				{
					sel.push_back(pFile->d_name);
				
					size += stat_bufs.st_size;
				}
			}
			closedir(handle);			
		}
		chdir (path.c_str());		
	}
	
	return sel;		
}

void MLSmain::select(file &f)
{
	if (f.name == "..") return;	
	if (f.selected) return;
	// 인덱스를 저장
	f.selected = true;	
	sel_size += f.size;	
	sel_num++;
}

void MLSmain::deselect(file &f)
{
	if (!f.selected) return;
	f.selected = false;
	sel_size -= f.size;	
	sel_num--;		
}
