#include <ncurses.h>
#include <vector>
#include <string>

#include "MLSmcd.h"
#include "config.h"
#include "dialog.h"

using namespace std;

MLSmcd::MLSmcd(const char *_title)
{
	title = _title;
	root = NULL;
	sRow = 0;
	sCol = 0;
	infofile = conf.cfghome +"treeinfo";
	code = "MLS1";
	
	if (load()==1)	rescan();
}

MLSmcd::~MLSmcd()
{
	if (root)
	for (pDirIterator p = order.begin(); p!=order.end(); ++p)
		delete *p;
}

string &
MLSmcd::dir::path()
{
	static pDirContainer st;
	static std::string p;
	dir *pNode=this;
	
	p.clear();
	st.clear();
	
	while(pNode->parent != NULL)
	{
		st.push_back(pNode);
		pNode= pNode->parent;
	}
	
	p = pNode->name;
	
	while(!st.empty())
	{
		p += st.back()->name;
		p += '/';
		st.pop_back();				
	}
	return p;																	
}

bool MLSmcd::proc()
{
	int key, bkey;	
	bExit = false;
	
	if (cur==order.end()) cur = order.begin();
	
	do
	{
		draw();		
		key = getch();
		
		switch(key)
		{
		case 13:
			return true;
			break;
		case KEY_UP:
			up();
			break;
			
		case KEY_DOWN:			
			down();			
			break;	
			
		case KEY_LEFT:
			left();	
			break;
		case KEY_RIGHT:
			right();			
			break;
			
		case '=':
		{
			string p = (*cur)->path();
			scan(*cur);
			setCur(p);
			break;
		}
		
		case '-':
		{
			string p = (*cur)->path();
			destroy(*cur);
			setCur(p);
			break;
		}
			
		case KEY_F(2):
		{
			int p= YNBox("Rescan directory now?", YN_Y, COLOR_MAGENTA);			
			if (p==YN_N || p==-1) break;
			
			string pa = (*cur)->path();						
			rescan();
			setCur(pa);
			break;
		}
			
		case 27:
			bkey = getch();
			switch(bkey)
			{
			case 27:
			case 'X':
			case 'x':
				return false; // 그냥 끝낸것임.. 디렉토리..;;
				break;
			}
			break;
		
		}		
	}while(!bExit);
	
	return true;
}
