#include <string>
#include "MLSmcd.h"

using namespace std;

void 
MLSmcd::setCur(string str)
{
	// 맨 뒤에 /이 없다면 붙인다.
	//               01234567890123456789
	// root->name = "/sdfsd/sdfsdsf/"
	//              "/sdfsd/sdfsdsf/p/3/"
	
	if (str.empty())
	{
		cur = order.begin();
		return;				
	}
	
	if (str[str.size()-1] != '/') str += '/';
	
	
	if (   str[0] != '/'                // 절대경로가 아닐때
		|| str==root->name				// 루트일때
		|| str.size() < root->name.size()  // 루트사이즈보다 작을때
		|| str.substr(0, root->name.size()) != root->name)
	{
		
		LOG("sdpfoajdsfoasd");
		cur = order.begin();
		return;
	}
	
	// /
	// 012345678901234
	// /home/ioklo/ppp
	
	string::size_type p = root->name.size()-1;
	string::size_type p2 = str.find_first_of('/', p+1);
	
	pDirIterator i;	
	dir *node = root;
	
	while (p2 != string::npos)
	{
		string t = str.substr(p+1, p2-p-1);
		
		// 자식들 중에 있는거 찾아낸다.
		for (i = node->node.begin(); i!=node->node.end() ;i++)
			if ((*i)->name == t) break;		
		
		if (i == node->node.end()) {cur = order.begin(); return;}
		
		node = (*i);
		p    = p2;
		p2   = str.find_first_of('/', p+1);
	}
		
	cur = order.begin() + (*i)->index;
}

void 
MLSmcd::up()
{
	pDirIterator i;
	
	if ((*cur)->parent)
	{		
		if ((*cur)->depth != (*(cur-1))->depth )
		{
			pDirIterator t;
			for (t = cur-1 ; t!=order.begin()-1; t--)
				if ((*t)->depth == (*cur)->depth) break;
				
			if (t != order.begin()-1) cur = t;
			else left();
		}
		else cur--;
	}
	else left();	
}

void 
MLSmcd::down()
{
	// 아래부분에 뭔가 있을 경우
	if ((*cur)->parent)
	{
		if (cur+1 == order.end() || (*cur)->depth != (*(cur+1))->depth )
		{
			pDirIterator t;
			for (t= cur+1 ; t!=order.end(); t++)
				if ((*t)->depth == (*cur)->depth) break;
				
			if (t != order.end()) cur = t;
			else right();
		}
		else cur++;
	}
	else right();
}

void
MLSmcd::left()
{
	if ((*cur)->parent) cur=order.begin()+(*cur)->parent->index;
	
}

void
MLSmcd::right()
{
	if (!(*cur)->node.empty()) cur=order.begin()+(*cur)->node.front()->index;
	else if (cur+1 != order.end()) cur++;
}



