#include <curses.h>
#include <vector>

#include "mls.h"
#include "MLSmcd.h"
#include "config.h"
#include "locale.h"
#include "drawutil.h"

using namespace std;
using namespace ch;

int col_location[6]={0, 4, 18, 32, 46, 60};

void MLSmcd::draw()
{
	vector<chtype> line;	
	dir *node, *pcur = *cur;	
	int row, col, odep=0;
	
	
	if (pcur->row - sRow > LINES - 5) sRow = pcur->row - LINES +5;
	if (pcur->depth - sCol > 5) sCol = pcur->depth - 5;
	if (pcur->row - sRow < 0) sRow = pcur->row;
	if (pcur->depth - sCol < 1)
	{
		 sCol = pcur->depth-1;	
		 if (sCol == -1) sCol=0;		 
	}	
	
	// 화면 지우기	
	setcol(conf.MCD);
	for (int i=0; i<LINES; i++)
		mvprintw(i, 0, "%80s", "");
	unsetcol();		
	
	// 타이틀
	setcol(conf.MCDstat);
		mvprintw(0, 0, "%-80.80s", title);
		mvprintw(LINES-1, 0, "F1-Help|F2-Rescan|F3-Drive|F4-Move|F5-Copy|F6-Ren|F7-Make|F8-Del|F9-Size|F11-QCD");
	unsetcol();		
	
	for (pDirIterator i=order.begin(); i!=order.end(); i++)
	{
		node = *i;
				
		if (odep < node->depth)
			line.push_back(VLINE);
		else
		while(node->depth < odep)
		{
			odep--;
			line.pop_back();
		}
		
		odep = node->depth;
		col  = node->depth;
		row  = node->row;
				
		// 출력 다했으면 종료		
		if (node->depth != 0 && node->parent->node.back()==node)
			line[col-1]=' ';
			
		if (row - sRow > LINES - 5) break;
		if (row - sRow < 0) continue;
		
		setcol(conf.MCD);		
		if (node != root && node->parent->node.front()!=node) 
			for (int t = sCol; t<col && t<sCol+5; t++)
				mvaddch(row-sRow+2, col_location[t-sCol+1], line[t]);			
		unsetcol();
		
		if (col - sCol > 5 ) continue;
		if (sCol != 0 && col - sCol < 1 ) continue;
						
		if (node->depth==0)
		{// 루트라면
			if (node == pcur) setrcol(conf.MCD);
			else setcol(conf.MCD);
			
			move(row-sRow+2, 2);
			addch('/');	
			
			unsetcol();
		}		
		else		
		{// 아니라면
			setcol(conf.MCD);
			
			if (node->parent->node.size() > 1)
			{// 디렉토리가 하나가 아닐때 
				if (node->parent->node.front()==node)
				{// 첫번째 노드 
					move(row-sRow+2, col_location[col-sCol]);					
					addch(TTEE);
				}
				else
				{// 그 이외의 디렉토리 
					move(row-sRow+2, col_location[col-sCol]);
										
					if (node->parent->node.back()==node) addch(LLCORNER);
					else addch(LTEE);					
				}	
			}
			else 
			{
				move(row-sRow+2, col_location[col-sCol]);
				addch(HLINE);
			}
			addch(HLINE);			
			
			unsetcol();			
						
			// 선을 하나 더 긋고 이름 출력 
			if (node == pcur) 
			{
				setrcol(conf.MCD);
				if (node->name.size() <= 12)
					printw("%-12s", node->name.c_str());					
				else 
					printw("%-11.11s~", node->name.c_str());			
			}				
			else
			{
				if (node->linked) setcol(11, conf.MCD.back);
				else setcol(conf.MCD);
				if (node->name.size() <= 12)
				{
					printw("%s", node->name.c_str());
					if (!node->node.empty())
						hline(HLINE, 12-node->name.size());
				}
				else printw("%-11.11s~", node->name.c_str());
			}			
			unsetcol();
		}
	}
	
	setcol(conf.MCD);
	mvprintw(LINES-2, 0, " Path %s", (*cur)->path().c_str());
	unsetcol();
	
	refresh();
}
