#ifndef __CONFIG_H__
#define __CONFIG_H__

#include <vector>
#include <list>
#include <string>
#include <map>

#include "drawutil.h"
	
// config
class config
{
public:
	// 펑션키 지정
	class prog
	{
	protected:
		
		std::string name;		
		std::vector<std::string> cmd;
		
		std::string nocmd;
		
	public:
	
		prog(){}
		
		unsigned int  size() {return cmd.size();}	
		void addEntry(std::string &);
		void addCommand(std::string c) {cmd.push_back(c);}
		void setName(std::string &a) {name=a;}
		
		std::string &operator [](unsigned int t){if (cmd.size() > t) return cmd[t]; return nocmd;}
		
		const char *getName() {if (cmd.empty()) return "None"; return name.c_str();}

	};	
	
public:
	std::list<std::string> filter; // 필터
	std::string date_type, extern_viewer, extern_editor;
	std::string home, cfghome, mcdroot;
	std::string colorset;
		
	// color
	color_entry MCD, MCDstat, Dir, Drive, Line, FuncN, FuncA, StatN, StatA, Else, Help, Quick, QuickMCD, Dialog;
	std::map<std::string, color_entry> ext_col;	
	std::map<std::string, prog> ext_prog;

	prog Func[12];  // F1~F12
	prog aFunc[12]; // F1~F12
	prog cFunc[12]; // F1~F12
	
	// toggle
	bool ShowHidden;	// .으로 시작하는 파일 보이기..
	bool AutoDrawmode;  // 그리기 방식을 자동으로 선택.
	bool FixedRow;      // 고정된 세로줄
	bool DirSort;		// DirSort

	int sort;           // 정렬방식
	int column;      // 그리기 방식(컬럼수)

	config();				
	~config();

	void set_default();
	int  load(const char *);
	int  load_colorset(const char *);
};


extern config conf;
#endif
