#ifndef dialog_h__
#define dialog_h__

#include <ncurses.h>
#include <string>

#define YN_Y 0
#define YN_N 1

int MsgBox(int color, const char *title, const char *msg,...);
int MsgBox(const char *title, const char *msg, int color=COLOR_RED);
int InputBox(const char *title, std::string &str, int color=COLOR_MAGENTA);
int YNBox(const char *title,int YN, int back_color=COLOR_CYAN);

class StatBox
{
protected:
	WINDOW *win;
	const char *title, *msg;
	int back_color;
		
	const char *UL, *UR, *BL, *BR;	
	int U, B;  	// 60 기준
				
public:
	StatBox(const char *,const char *, int back_color=COLOR_MAGENTA);
	~StatBox();
	
	void setUL(const char *p){UL=p;}
	void setUR(const char *p){UR=p;}
	void setBL(const char *p){BL=p;}
	void setBR(const char *p){BR=p;}
	
	void setU(int p){U=p; if (U<0) U=0; if (U>60) U=60;}
	void setB(int p){B=p; if (B<0) B=0; if (B>60) B=60;}
			
	void show();
	void redraw();
};

#endif//dialog_h__
