#ifndef DRAWUTIL_H
#define DRAWUTIL_H

#include <ncurses.h>

#define COLOR(fg, bg) COLOR_PAIR(((fg)<<3)+(bg))

struct color_entry
{
	color_entry() : font(0), back(0) {}
	color_entry(char *line)
	{
		
		char *p = strchr (line, ',');
		
		if (p != NULL)
		{
			*p=0;
			
			back = atoi(p+1);
			font = atoi(line);			
		}
		else
		{
			font = atoi(line);
			back = 0;
		}		
	}
	int font, back;
	
	bool operator == (color_entry &t)
	{
		return font==t.font && back==t.back;
	}
	
	bool operator < (color_entry &t)
	{
		return font*16+back > t.font*16+t.back;
	}
};

inline void setcol(int font, int back)
{
	if ( font >=8 ) attron(A_BOLD);
	if ( back >=8 ) attron(A_BLINK);
	
	attron(COLOR_PAIR( ((font%8) << 3) + (back%8)));
}

inline void setcol(color_entry &p)
{
	if ( p.font >=8 ) attron(A_BOLD);
	if ( p.back >=8 ) attron(A_BLINK);
	
	attron(COLOR_PAIR( ((p.font%8) << 3) + (p.back%8)));
}

inline void setrcol(color_entry &p)
{
	if ( p.font >=8 ) attron(A_BLINK);
	if ( p.back >=8 ) attron(A_BOLD);
	
	attron(COLOR_PAIR( ((p.back%8) << 3) + (p.font%8)));
}


inline void unsetcol()
{
	attroff(A_BOLD | A_BLINK);	
}




#endif
