#ifndef STRUTIL_H__
#define STRUTIL_H__ 1

#include <string>
#include <math.h>

namespace strutil
{
	using namespace std;
	
inline string tolower(string p)
{
	string r;
	for(string::iterator i = p.begin(); i!=p.end(); i++)
	{
		if ('A' <= *i && *i <= 'Z') r += *i-'A'+'a';	
		else r += *i;
	}
	return r;
}

inline string chop(string p)
{
	string::size_type f = p.find_first_not_of(" \n\r");
	string::size_type r = p.find_last_not_of(" \n\r");
	
	if (f == string::npos || r== string::npos) return "";
	
	return p.substr(f, r-f+1);
}

inline string getbetween(string p, const char f, const char r)
{
	string::size_type s = p.find_first_of(f);
	if (s == string::npos) return "";
	string::size_type s2 = p.find_first_of(r, s+1);
	if (s2 == string::npos) return "";	
	
	return p.substr(s+1 , s2-s-1);	
}

inline string replace(string p, const char*find, const char*replace)
{
	//  01234567890123456789012
	// "the great great bassist" "great" "brother"	
	string arg;
	
	string::size_type t = 0;
	string::size_type t2= p.find(find);
	
	string::size_type len = strlen(find);
	
	while(t2 != string::npos)
	{
		arg += p.substr(t, t2-t);
		arg += replace;
		
		t = t2 + len;
		t2 = p.find(find, t);
	}
	
	arg += p.substr(t);
	
	return arg;
}

inline string addslashes(string p)
{// ' " \ NUL
    // 0         1         2
	// 012345678901234567890123456789
	// It is in I'm not ss"ss\;;
	string arg;
	
	string::size_type t = 0;
	string::size_type t2= p.find_first_of(" '\"\\\0");
		
	while(t2 != string::npos)
	{
		arg += p.substr(t, t2-t);
		arg += '\\';
		arg += p[t2];		
		
		t = t2 + 1;
		t2 = p.find_first_of(" '\"\\\0", t);
	}	
	arg += p.substr(t);
	
	return arg;		
}

inline string& toregular(int number)
{
	// 자리수 맞추기..;
	int n=1, p=1;
	static string str;
	str.clear();
	
	while(number >= p*10) {p*=10; n++;}	
	
	while (n)
	{
		str += ('0' + (number / p));
		
		number %= p;
		p /= 10;
		n --;
		
		if (n!=0 && n%3 ==0) str+= ',';		
	}
	return str;
					
}

inline char *tolower(char *str)
{
	char *p=str;
	while(*p!=0) {
		if ('A' <= *p && *p <= 'Z') *p=*p-'A'+'a';
		p++;
	}
	return str;
}

inline char *chop(char *str)
{
	if (*str==0) return 0;
	
	char *begin=str;
	char *p=&str[strlen(str)-1];
	
	while(*begin == ' ')
	{
		begin++;
		if (*begin == 0) break;
	}
	
	while(*p == ' ' || *p=='\n' || *p=='\r')
	{
		*p=0;
		p--;
		if (p <= begin) break;
	}
	//
	p=begin;
	while(*p==0) {
		if ('A' <= *p && *p <= 'Z') *p=*p-'A'+'a';
		p++;
	}	
	return begin;
}


};

#endif//STRUTIL_H__
